module Main exposing (main)

import Array exposing (Array)
import Benchmark exposing (..)
import Benchmark.Runner exposing (BenchmarkProgram, program)
import Dict exposing (Dict)
import RemoveDiacritics
import Set exposing (Set)
import String.Normalize as Normalize


main : BenchmarkProgram
main =
    program suite


suite : Benchmark
suite =
    let
        aboveMinString =
            "£££££££££££££££££££££££££££££££££££££"

        belowMinString =
            "asdfereqerqerpqoiweruqwerqwerpqoweAAA"

        bench description str =
            Benchmark.compare description
                "original"
                (\_ -> Normalize.removeDiacritics str)
                "new"
                (\_ -> RemoveDiacritics.removeDiacritics str)
    in
    Benchmark.describe "remove diacritics"
        [ bench "below lowest diacritic code" belowMinString
        , bench "above lowest diacritic code" aboveMinString
        ]
